unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TntStdCtrls, ExtCtrls,
  TntExtCtrls, TntExDropDownEdit, TntExButtonEdit, XPMan, TntExDropDownMemo,
  ComCtrls, TntComCtrls, TntExDropDownRichEdit, ExtActns, TntExtActns,
  ActnList, StdActns, TntActnList, Menus, TntMenus,
  TntExDropDownVirtualStringTree, virtualtrees, ImgList, TntExIntegerEdit,
  TntExWinControl, TntExDropDownControl, TntExDropDownVirtualDrawTree;

type
  TForm1 = class(TForm)
    TntExButtonEdit1: TTntExButtonEdit;
    TntExDropDownMemo1: TTntExDropDownMemo;
    TntExDropDownRichEdit1: TTntExDropDownRichEdit;
    TntPopupMenu1: TTntPopupMenu;
    TntActionList1: TTntActionList;
    RichEditBold1: TTntRichEditBold;
    RichEditItalic1: TTntRichEditItalic;
    RichEditUnderline1: TTntRichEditUnderline;
    RichEditStrikeOut1: TTntRichEditStrikeOut;
    RichEditBullets1: TTntRichEditBullets;
    RichEditAlignLeft1: TTntRichEditAlignLeft;
    RichEditAlignRight1: TTntRichEditAlignRight;
    RichEditAlignCenter1: TTntRichEditAlignCenter;
    TntLabel1: TTntLabel;
    TntLabel3: TTntLabel;
    TntLabel4: TTntLabel;
    Bullets1: TTntMenuItem;
    N1: TTntMenuItem;
    Underline1: TTntMenuItem;
    Strikeout1: TTntMenuItem;
    Italic1: TTntMenuItem;
    Bold1: TTntMenuItem;
    N2: TTntMenuItem;
    AlignRight1: TTntMenuItem;
    Center1: TTntMenuItem;
    AlignLeft1: TTntMenuItem;
    TntExDropDownVirtualStringTree1: TTntExDropDownVirtualStringTree;
    ImageList1: TImageList;
    TntCheckBox1: TTntCheckBox;
    TntLabel2: TTntLabel;
    TntExIntegerEdit1: TTntExIntegerEdit;
    TntExIntegerEdit2: TTntExIntegerEdit;
    TntExDropDownVirtualDrawTree1: TTntExDropDownVirtualDrawTree;
    procedure TntExDropDownVirtualStringTree1DropDownTreeGetText(
      Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType; var CellText: WideString);
    procedure TntExDropDownVirtualStringTree1DropDownTreeGetImageIndex(
      Sender: TBaseVirtualTree; Node: PVirtualNode; Kind: TVTImageKind;
      Column: TColumnIndex; var Ghosted: Boolean; var ImageIndex: Integer);
    procedure FormCreate(Sender: TObject);
    procedure TntCheckBox1Click(Sender: TObject);
    procedure TntExDropDownVirtualStringTree1DropDownTreeIncrementalSearch(
      Sender: TBaseVirtualTree; Node: PVirtualNode;
      const SearchText: WideString; var Result: Integer);
    procedure TntExButtonEdit1EditButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Math;

{$R *.dfm}

procedure TForm1.TntExDropDownVirtualStringTree1DropDownTreeGetText(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType; var CellText: WideString);
begin

  CellText := inttostr(node.Index) + ' Node ';
end;

procedure TForm1.TntExDropDownVirtualStringTree1DropDownTreeGetImageIndex(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Kind: TVTImageKind;
  Column: TColumnIndex; var Ghosted: Boolean; var ImageIndex: Integer);
begin
  case kind of
    ikNormal,ikSelected : imageindex := (node.Index mod 26);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
  procedure AddNodes(Tree: TCustomVirtualStringTree; parent : pvirtualnode; level : integer);
  var
    i : integer;
    n : pvirtualnode;
  begin
    if level > 3 then exit;
    for i := 0 to RandomRange(1,5) do
    begin
      n := tree.AddChild(parent);
      AddNodes(Tree,n,level + 1);
    end;
  end;
var
  n : pvirtualnode;
begin
  n := TntExDropDownVirtualStringTree1.Tree.GetFirst;
  while n <> nil do
  begin
    n := TntExDropDownVirtualStringTree1.Tree.GetNextSibling(n);
    AddNodes(TntExDropDownVirtualStringTree1.Tree,n,1);
  end;
end;

procedure TForm1.TntCheckBox1Click(Sender: TObject);
begin
  TntExDropDownVirtualStringTree1.Enabled := NOT TntExDropDownVirtualStringTree1.Enabled; 
end;

procedure TForm1.TntExDropDownVirtualStringTree1DropDownTreeIncrementalSearch(
  Sender: TBaseVirtualTree; Node: PVirtualNode;
  const SearchText: WideString; var Result: Integer);
var
  nodeText : widestring;
begin
  result := 1;
  if sender is TVirtualStringTree then
  begin
    with sender as TVirtualStringTree do
    begin
      if assigned(OnGetText) then OnGetText(sender,Node,Header.MainColumn,ttNormal,nodeText);
    end;
    if widesametext(SearchText,copy(nodetext,1,length(searchtext))) then result := 0;
  end;
end;

procedure TForm1.TntExButtonEdit1EditButtonClick(Sender: TObject);
begin
  Showmessage('Click');
end;

end.
