{*****************************************************************************}
{                                                                             }
{    Tnt Extended Editors                                                     }
{      http://lummie.co.uk                                                    }
{        Version: 1.0.3                                                       }
{                                                                             }
{    Copyright (c) 2005 Matt harrison (http://www.lummie.co.uk)               }
{    Descended from TNT Controls                                              }
{        Copyright (c) 2002, 2003 Troy Wolbrink (troy.wolbrink@ccci.org)      }                                                                   
{                                                                             }
{*****************************************************************************}
unit TntExButtonEdit;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, TntStdCtrls, windows, messages;

type
  TTntExButtonEdit = class(TTntEdit)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FButton : TTntButton;
    procedure Change; override;
    procedure CreateWnd; override;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure UpdateButtonPos;
    procedure CMEnabledchanged(var Message: TMessage); message CM_ENABLEDCHANGED;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Button : TTntButton read FButton;
  end;

implementation

{ TTntExButtonEdit }

procedure TTntExButtonEdit.Change;
begin
  inherited;
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
end;

procedure TTntExButtonEdit.CMEnabledchanged(var Message: TMessage);
begin
  FButton.Enabled := Enabled;
  inherited;
end;

constructor TTntExButtonEdit.Create(AOwner: TComponent);
begin
  inherited;
  FButton := TTntButton.create(self);
  FButton.Width := 20;
  FButton.Parent := self;
  FButton.Caption := '...';
  FButton.name := 'EditButton';
  FButton.SetSubComponent(true);
end;

procedure TTntExButtonEdit.CreateWnd;
begin
  inherited;
  UpdateButtonPos;
end;

destructor TTntExButtonEdit.Destroy;
begin
  FreeAndNil(FButton);
  inherited;
end;

procedure TTntExButtonEdit.UpdateButtonPos;
begin
  FButton.SetBounds(width - FButton.Width - 4,0,FButton.width,height-4);
  Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
end;

procedure TTntExButtonEdit.WMSize(var Message: TWMSize);
begin
  UpdateButtonPos;
end;

end.
