{*****************************************************************************}
{                                                                             }
{    Tnt Extended Editors                                                     }
{      http://lummie.co.uk                                                    }
{        Version: 1.0.3                                                       }
{                                                                             }
{    Copyright (c) 2005 Matt harrison (http://www.lummie.co.uk)               }
{    Descended from TNT Controls                                              }
{        Copyright (c) 2002, 2003 Troy Wolbrink (troy.wolbrink@ccci.org)      }                                                                   
{                                                                             }
{*****************************************************************************}
unit TntExDropDownControl;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, TntStdCtrls, TntExButtonEdit, windows, messages,
  ExtCtrls, graphics, TntMenus, forms, tntExtCtrls, TntExWinControl;

const
  CM_ChangePanelVisiblity = WM_USER + 875;
  ResizeSize = 4;

type
  TCMChangePanelVisible = TWMShowWindow;

  TCustomTntExDropDownControl = class;

  TTntExDropDownPanel = class(TCustomPanel)
  protected
    FDropDown : TCustomTntExDropDownControl;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer);
      override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X: Integer; Y: Integer); override;
    procedure AdjustClientRect(var Rect: TRect); override;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure CreateWnd; override;
    procedure WMActivateApp(var Message: TWMActivateApp);
      message WM_ACTIVATEAPP;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  TCustomTntExDropDownControl = class(TTntExWinControl)
  private
    { Private declarations }
    FPanel : TTntExDropDownPanel;
    FPopulated : boolean;
    FPanelHeight: integer;
    FPanelWidth: integer;
    FClosing : boolean;
    FOnDroppedDown : TNotifyEvent;
    FOnClosedUp: TNotifyEvent;
    FButtonPressed : boolean;
    FMouseInControl : boolean;
    FUpdating : boolean;
    FDropDownPopupMenu: TTntPopupMenu;
    FRedirectingContextMenu : boolean;
    FPanelAutoWidth: boolean;
    FPanelAllowResize: boolean;
  protected
    { Protected declarations }
    procedure GetPanelRect(var ARect : TRect); virtual;
    procedure DoButtonClick; virtual;
    function GetButtonRect : TRect; virtual;
    function GetButtonWidth : integer; virtual;
    procedure CMChangePanelVisibility(var Msg : TCMChangePanelVisible); message CM_ChangePanelVisiblity;
    procedure CreateWnd; override;
    function DoPopulatePanel(APanel : TTntExDropDownPanel) : boolean; virtual;
    procedure DoDroppedDown; virtual;
    procedure DoClosedUp; virtual;
    procedure UpdatePanelPosition; virtual;
    procedure WMMove(var Message: TWMMove); message WM_MOVE;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer); override;
    function HitButton(x,y : integer) : boolean; virtual;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure CMMouseenter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseleave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer);
      override;
    procedure DoExit; override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
    procedure Notification(AComponent: TComponent; Operation: TOperation);
      override;
    procedure WndProc(var Message: TMessage); override;
    procedure DropDown; dynamic;
    procedure CloseUp; dynamic;
    procedure WMLButtonDown(var Message: TWMLButtonDown);
      message WM_LBUTTONDOWN;
    procedure NonEditMouseDown(var Message: TWMLButtonDown);
    property Panel : TTntExDropDownPanel read FPanel;
    procedure Paint; override;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    function GetClientRect: TRect; override;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMEnabledchanged(var Message: TMessage);
      message CM_ENABLEDCHANGED;
  public
    { Public declarations }
    procedure ShowPanel(MakeVisible: boolean);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Closing : boolean read FClosing;
    function IsDroppedDown : boolean;
    property PanelAutoWidth : boolean read FPanelAutoWidth write FPanelAutoWidth;
    property PanelWidth : integer read FPanelWidth write FPanelWidth;
    property PanelHeight : integer read FPanelHeight write FPanelHeight;
    property OnDroppedDown : TNotifyEvent read FOnDroppedDown write FOnDroppedDown;
    property OnClosedUp : TNotifyEvent read FOnClosedUp write FOnClosedUp;
    property DropDownPopupMenu : TTntPopupMenu read FDropDownPopupMenu write FDropDownPopupMenu;
    property PanelAllowResize : boolean read FPanelAllowResize write FPanelAllowResize;
  end;

  TTntExDropDownControl = class(TCustomTntExDropDownControl)
  public
    property DockManager;
  published
    { Published declarations }
    property PanelAutoWidth;
    property PanelWidth;
    property PanelHeight;
    property OnDroppedDown;
    property OnClosedUp;
    property DropDownPopupMenu;

    property Align;
    property Anchors;
    property AutoSize;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderWidth;
    property Caption;
    property Color;
    property Constraints;
    property Ctl3D;
    property UseDockManager default True;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    {$IFDEF COMPILER_7_UP}
    property ParentBackground;
    {$ENDIF}
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

implementation

uses
  themes, Types;

{ TTntExDropDownPanel }

procedure TTntExDropDownPanel.AdjustClientRect(var Rect: TRect);
begin
  Rect.bottom := Rect.bottom - ResizeSize;
  inherited;
end;

constructor TTntExDropDownPanel.Create(AOwner: TComponent);
begin
  inherited;
  FDropDown := TCustomTntExDropDownControl(AOwner);
  ControlStyle := ControlStyle + [csNoDesignVisible] - [csParentBackground];
  visible := false;
  TabStop := false;
  Constraints.MinHeight := 10;
  Constraints.MinWidth := 10;
end;

procedure TTntExDropDownPanel.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_POPUP;
    ExStyle := ExStyle or WS_EX_TOOLWINDOW + WS_EX_LEFT  and not WS_EX_APPWINDOW;
    AddBiDiModeExStyle(ExStyle);
    WindowClass.Style := CS_SAVEBITS;
  end;
end;


procedure TTntExDropDownPanel.CreateWnd;
begin
  inherited;
  if not (csDesigning in ComponentState) then
    Windows.SetParent(Handle, 0);
  CallWindowProc(DefWndProc, Handle, WM_SETFOCUS, 0, 0);
end;

destructor TTntExDropDownPanel.Destroy;
begin
  inherited;
end;

procedure TTntExDropDownPanel.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
  SC_DRAGSIZE_SE = $F008;
  SC_DRAGSIZE_S = $F006;
begin
  if FDropDown.PanelAllowResize and ptinRect(Rect(0, height-ResizeSize, width-ResizeSize, height),point(x,y)) then
  begin
    ReleaseCapture;
    FDropDown.PanelAutoWidth := false;
    Perform(WM_SYSCOMMAND,SC_DRAGSIZE_S,0);
  end
  else if FDropDown.PanelAllowResize  and ptinRect(Rect(width-ResizeSize,height-ResizeSize,width,height),point(x,y)) then
  begin
    ReleaseCapture;
    FDropDown.PanelAutoWidth := false;
    Perform(WM_SYSCOMMAND,SC_DRAGSIZE_SE,0);
  end
  else
    inherited;
end;

procedure TTntExDropDownPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if FDropDown.PanelAllowResize  and ptinRect(Rect(0, height-ResizeSize, width-ResizeSize, height),point(x,y)) then
    cursor := crSizeNS
  else if FDropDown.PanelAllowResize  and ptinRect(Rect(width-ResizeSize,height-ResizeSize,width,height),point(x,y)) then
    cursor := crSizeNWSE
  else
    cursor := crDefault;
end;

procedure TTntExDropDownPanel.WMActivate(var Message: TWMActivate);
begin
  if (Message.Active = WA_INACTIVE) and not(FDropDown.Closing) then
  begin
    if assigned(FDropDown) then if Visible then FDropDown.ShowPanel(false)
  end;
  {
  else}
    inherited;
end;

{ TTntDropDownEdit }

procedure TCustomTntExDropDownControl.CMChangePanelVisibility(
  var Msg: TCMChangePanelVisible);
begin
  // override sub controls can post a CM_ChangePanelVisibility message to hide and show the panel 
  ShowPanel(msg.Show);
end;

constructor TCustomTntExDropDownControl.Create(AOwner: TComponent);
begin
  inherited;
  DoubleBuffered := true;
  FPanelAllowResize := true;
  FPanelAutoWidth := true;
  FDropDownPopupMenu := nil;
  FUpdating := false;
  FButtonPressed := false;
  FPopulated := false;
  FPanel := TTntExDropDownPanel.create(self);
  FPanel.Visible := true;
  FPanel.parent := self;
  FClosing := false;
  FOnDroppedDown := nil;
  FOnClosedUp := nil;
  FPanelHeight := 0;
  FPanelWidth := 0;
  TabStop := true;
end;

procedure TCustomTntExDropDownControl.CreateWnd;
begin
  inherited;
  FPanel.HandleNeeded;
  FPanel.Visible := false;
end;

destructor TCustomTntExDropDownControl.Destroy;
begin
  inherited;
end;

procedure TCustomTntExDropDownControl.ShowPanel(MakeVisible : boolean);
begin
  if MakeVisible then DropDown else CloseUp;
end;

procedure TCustomTntExDropDownControl.GetPanelRect(var ARect: TRect);
begin
  // returns where to display the drop down.
  // note the right and bottom are width and height
  if (FPanelHeight = 0) and (FPanelWidth = 0) then
  begin
    FPanelHeight := Height * 8;
    FPanelWidth := width + GetButtonWidth - 1;
  end;

  ARect.TopLeft := ClientOrigin;
  ARect.Left := ARect.left -0;
  ARect.Top := ARect.Top + Height -2;
  if FPanelAutoWidth then
    ARect.Right := Width
  else
    ARect.Right := FPanelWidth;
  ARect.bottom := FPanelHeight;
end;


function TCustomTntExDropDownControl.DoPopulatePanel(
  APanel: TTntExDropDownPanel): boolean;
begin
  // override to create a sub control of the panel, e.g. a list box and do the initiali setup here.
  // if you return true this function will never get called again
  // if you return false, this function will get called just before everytime the panel is dropped down.
  result := true;
end;

procedure TCustomTntExDropDownControl.DoClosedUp;
begin
  // override to do something after the panel is closed up
  if assigned(FOnClosedUp) then FOnClosedUp(self);
end;

procedure TCustomTntExDropDownControl.DoDroppedDown;
begin
  // override to do something after the panel is droped down
  if assigned(FOnDroppedDown) then FOnDroppedDown(self);
end;


procedure TCustomTntExDropDownControl.UpdatePanelPosition;
var
  ARect : TRect;
  AMonitor : TMonitor;
  dx,dy : integer;
begin
  // this procedure actuall moves the panel to the correct position
  // override getPanelRect to move it elsewhere
  GetPanelRect(ARect);
  AMonitor := Screen.MonitorFromPoint(ARect.TopLeft);
  dx := AMonitor.width - (ARect.left + ARect.Right);
  dy := AMonitor.Height - (ARect.top + Arect.bottom);

  if (dx < 0) then
  begin
    ARect.left := ARect.left - (ARect.right - width);
  end;
  if (dy < 0) then
  begin
    ARect.Top := Arect.top-height-ARect.bottom;
  end;

  if assigned(FPanel) then FPanel.SetBounds(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
  SetWindowPos(FPanel.Handle,0,ARect.Left,ARect.Top,ARect.Right,ARect.Bottom, SWP_NOACTIVATE);
end;

procedure TCustomTntExDropDownControl.WMMove(var Message: TWMMove);
begin
  UpdatePanelPosition;
end;

procedure TCustomTntExDropDownControl.WMSize(var Message: TWMSize);
begin
end;

procedure TCustomTntExDropDownControl.DoButtonClick;
begin
  // override to alter what happens when the button is clicked
  if enabled then SetFocus;
  if not FClosing then ShowPanel(not FPanel.Visible);
end;

procedure TCustomTntExDropDownControl.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if HitButton(x,y) then
  begin
    FButtonPressed := true;
    DoButtonClick;
  end;
  invalidate;
end;

function TCustomTntExDropDownControl.HitButton(x, y: integer): boolean;
var
  pt : TPoint;
begin
  // override to change the button hit test if needed
  pt := point(x,y);
  result := ptinrect(Rect(Width-GetButtonWidth,0,width,height),pt);
end;

function TCustomTntExDropDownControl.GetButtonWidth: integer;
begin
  // override to change the width of the button
    result := GetSystemMetrics(SM_CXVSCROLL) + 2;
end;

procedure TCustomTntExDropDownControl.WMPaint(var Message: TWMPaint);
begin
  inherited;
end;

procedure TCustomTntExDropDownControl.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  FButtonPressed := false;
  invalidate;
end;

procedure TCustomTntExDropDownControl.CMMouseenter(var Message: TMessage);
begin
  inherited;
  {Windows XP themes use hot track states, hence we have to update the drop down button.}
  if ThemeServices.ThemesEnabled and not (FMouseInControl) and not (csDesigning in ComponentState) then
  begin
    FMouseInControl := True;
    Invalidate;
  end;
end;

procedure TCustomTntExDropDownControl.CMMouseleave(var Message: TMessage);
begin
  inherited;
  if ThemeServices.ThemesEnabled and FMouseInControl then
  begin
    FMouseInControl := False;
    Invalidate;
    Cursor := crDefault;
  end;
end;

function TCustomTntExDropDownControl.GetButtonRect: TRect;
begin
  // override to change the position of the button
  result := inherited getClientRect;
  result.Left := result.right-GetButtonWidth-2;
  result.right := result.left+GetButtonWidth;
  result.Top := result.top + 2;
  result.bottom := result.bottom -2;
end;

procedure TCustomTntExDropDownControl.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if HitButton(x,y) then
    Cursor := crArrow
  else
    Cursor := crDefault;
end;

procedure TCustomTntExDropDownControl.DoExit;
begin
  inherited;
  If IsDroppedDown then ShowPanel(false);
  Invalidate;
end;

function TCustomTntExDropDownControl.IsDroppedDown: boolean;
begin
  result := FPanel.Visible;
end;

procedure TCustomTntExDropDownControl.KeyUp(var Key: Word; Shift: TShiftState);
begin
  inherited;
end;

procedure TCustomTntExDropDownControl.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;

  if (Key = VK_Down) and (ssAlt in Shift) then
  begin
    ShowPanel(not IsDroppedDown);
  end;

  if (Key = VK_RETURN) or (key = VK_Escape) then
  begin
    if IsDroppedDown then CloseUp;
  end;

end;

procedure TCustomTntExDropDownControl.WMActivate(var Message: TWMActivate);
begin
  if (Message.Active = WA_INACTIVE) and not(Closing) then
    ShowPanel(false);
  {else}
  inherited;
end;


procedure TTntExDropDownPanel.WMActivateApp(var Message: TWMActivateApp);
begin
  if (message.Active = false) and (visible) then
    FDropDown.CloseUp;
  inherited;
end;

procedure TTntExDropDownPanel.WMSize(var Message: TWMSize);
begin
  if assigned(FDropDown) then
  begin
    FDropDown.FPanelWidth := Message.Width;
    FDropDown.FPanelHeight := Message.Height;
  end;
  realign;
end;

procedure TCustomTntExDropDownControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (operation = opRemove) and (AComponent = FDropDownPopupMenu) then FDropDownPopupMenu := nil;
end;

procedure TCustomTntExDropDownControl.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_CONTEXTMENU :
    begin
      if assigned(FPanel) and (FPanel.HandleAllocated) and (Fpanel.Visible) then
      begin
        if (TWMContextMenu(Message).hWnd = FPanel.handle) then // right click on actual drop down then throw away.
        begin
          message.Result := 0;
        end
        else
        begin  // send message to panel
          if not FRedirectingContextMenu then
          begin
            FRedirectingContextMenu := true;
            with TMessage(Message) do
              SendMessage(FPanel.Handle, Msg, WParam, LParam);
            FRedirectingContextMenu := false;
          end
          else
          begin
            if Parent.HandleAllocated then
              with TMessage(Message) do
                SendMessage(Parent.Handle, Msg, WParam, LParam);
          end;
        end;
      end
      else
      begin
        inherited;
      end;
    end;
  else
    inherited;
  end
end;

procedure TCustomTntExDropDownControl.CloseUp;
begin
  FClosing := true;
  if enabled then SetFocus;
  FPanel.Visible := false;
  DoClosedUp;
  FClosing := false;
end;

procedure TCustomTntExDropDownControl.DropDown;
begin
  if not FPopulated then
  begin
    FPopulated := DoPopulatePanel(FPanel);
  end;
  UpdatePanelPosition;
  FPanel.Visible := True;
  if FPanel.enabled then FPanel.SetFocus;
  DoDroppedDown;
end;

procedure TCustomTntExDropDownControl.WMLButtonDown(var Message: TWMLButtonDown);
begin
  NonEditMouseDown(Message);
  inherited;
end;

procedure TCustomTntExDropDownControl.NonEditMouseDown(var Message: TWMLButtonDown);
begin
  if enabled then SetFocus;
  if FPanel.Visible then
    CloseUp
  else
    DropDown;
end;

procedure TCustomTntExDropDownControl.Paint;
var
  State : TThemedComboBox;
  Details: TThemedElementDetails;
  R, FocusRect : TRect;
  Flags : integer;
begin
  inherited;

  R := GetButtonRect;

  if Focused then
  begin
    FocusRect := inherited getClientRect;
    FocusRect.Right := r.Left;
    inflateRect(FocusRect,-3,-3);
    canvas.Brush.color := clHighlight;
    canvas.FillRect(FocusRect);
    DrawFocusRect(Canvas.Handle,FocusRect);
  end;

  if ThemeServices.ThemesEnabled then
  begin
    if not enabled then
      State := tcDropDownButtonDisabled
    else
      if FButtonPressed then
        State := tcDropDownButtonPressed
      else
        if FMouseInControl and not FPanel.Visible then
          State := tcDropDownButtonHot
        else
          State := tcDropDownButtonNormal;
    Details := ThemeServices.GetElementDetails(State);
    ThemeServices.DrawElement(Canvas.Handle, Details, R);
  end

  else

  begin
    // NON THEMED DRAWING
    R := GetButtonRect;


    if not (Enabled) then
      Flags := DFCS_SCROLLCOMBOBOX or DFCS_INACTIVE
    else if FButtonPressed then
      Flags := DFCS_SCROLLCOMBOBOX or DFCS_FLAT or DFCS_PUSHED
    else
      Flags := DFCS_SCROLLCOMBOBOX;
    DrawFrameControl(Canvas.Handle, R, DFC_SCROLL, Flags);
  end;
end;

procedure TCustomTntExDropDownControl.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  invalidate;
end;

function TCustomTntExDropDownControl.GetClientRect: TRect;
begin
  result := inherited GetClientRect;
end;


procedure TCustomTntExDropDownControl.WMKeyDown(var Message: TWMKeyDown);
begin
  inherited;
end;


procedure TCustomTntExDropDownControl.WMGetDlgCode(
  var Message: TWMGetDlgCode);
begin
    Message.Result := Message.Result or DLGC_WANTARROWS;
end;

procedure TCustomTntExDropDownControl.CMEnabledchanged(
  var Message: TMessage);
begin
  inherited;
end;

end.
