{*****************************************************************************}
{                                                                             }
{    Tnt Extended Editors                                                     }
{      http://lummie.co.uk                                                    }
{        Version: 1.0.3                                                       }
{                                                                             }
{    Copyright (c) 2005 Matt harrison (http://www.lummie.co.uk)               }
{    Descended from TNT Controls                                              }
{        Copyright (c) 2002, 2003 Troy Wolbrink (troy.wolbrink@ccci.org)      }                                                                   
{                                                                             }
{*****************************************************************************}
unit TntExDropDownMemo;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, TntStdCtrls, TntExDropDownEdit, Forms, windows;

type
  TTntExDropDownMemo = class(TTntExDropDownEdit)
  private
    { Private declarations }
    FMemo : TTntMemo;
    procedure MemoChange(Sender : TObject);
    procedure MemoKeyDown(Sender : TObject; var Key: Word; Shift: TShiftState);
  protected
    { Protected declarations }
    function DoPopulatePanel(APanel: TTntExDropDownPanel): Boolean; override;
    procedure DoDroppedDown; override;
    procedure DoClosedUp; override;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

implementation

{ TTntExDropDownMemo }

procedure TTntExDropDownMemo.DoClosedUp;
begin
  inherited;
  SelectAll;
end;

procedure TTntExDropDownMemo.DoDroppedDown;
begin
  inherited;
  FMemo.HandleNeeded;
  FMemo.Text := Text;
  FMemo.SetFocus;
  FMemo.SelectAll;
end;

function TTntExDropDownMemo.DoPopulatePanel(
  APanel: TTntExDropDownPanel): Boolean;
begin
  result := true;
  FMemo := TTntMemo.create(APanel);
  FMemo.align := alclient;
  FMemo.Parent := APanel;
  FMemo.OnKeyDown := MemoKeyDown;
  FMemo.OnChange := MemoChange;
  FMemo.BorderStyle := bsNone;
  FMemo.WantReturns := false;
end;

procedure TTntExDropDownMemo.MemoChange(Sender: TObject);
begin
  Text := FMemo.Text;
end;

procedure TTntExDropDownMemo.MemoKeyDown(Sender : TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = []) then
  begin
    case key of
      VK_Escape, VK_Return : KeyDown(Key,Shift);
    end;
  end;
  if (ssAlt in Shift) and (Key = VK_Down) then KeyDown(Key,Shift);
end;

end.
