{*****************************************************************************}
{                                                                             }
{    Tnt Extended Editors                                                     }
{      http://lummie.co.uk                                                    }
{        Version: 1.0.3                                                       }
{                                                                             }
{    Copyright (c) 2005 Matt harrison (http://www.lummie.co.uk)               }
{    Descended from TNT Controls                                              }
{        Copyright (c) 2002, 2003 Troy Wolbrink (troy.wolbrink@ccci.org)      }                                                                   
{                                                                             }
{*****************************************************************************}
unit TntExDropDownRichEdit;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, TntStdCtrls, TntExDropDownEdit, Forms, windows,
  ComCtrls, TntComCtrls;

type
  TTntExDropDownRichEdit = class(TTntExDropDownEdit)
  private
    { Private declarations }
    FRichEdit : TTntRichEdit;
    procedure MemoChange(Sender : TObject);
    procedure MemoKeyDown(Sender : TObject; var Key: Word; Shift: TShiftState);
  protected
    { Protected declarations }
    function DoPopulatePanel(APanel: TTntExDropDownPanel): Boolean; override;
    procedure DoDroppedDown; override;
    procedure DoClosedUp; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);
      override;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

implementation

{ TTntExDropDownRichEdit }

procedure TTntExDropDownRichEdit.DoClosedUp;
begin
  inherited;
  SelectAll;
end;

procedure TTntExDropDownRichEdit.DoDroppedDown;
begin
  inherited;
  FRichEdit.Text := Text;
  FRichEdit.SetFocus;
  FRichEdit.SelectAll;
end;

function TTntExDropDownRichEdit.DoPopulatePanel(
  APanel: TTntExDropDownPanel): Boolean;
begin
  result := true;
  FRichEdit := TTntRichEdit.create(APanel);
  FRichEdit.align := alclient;
  FRichEdit.Parent := APanel;
  FRichEdit.OnKeyDown := MemoKeyDown;
  FRichEdit.OnChange := MemoChange;
  FRichEdit.BorderStyle := bsNone;
  FRichEdit.WantReturns := false;
  FRichEdit.PopupMenu := DropDownPopupMenu;
end;

procedure TTntExDropDownRichEdit.MemoChange(Sender: TObject);
begin
  Text := FRichEdit.Text;
end;

procedure TTntExDropDownRichEdit.MemoKeyDown(Sender : TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = []) then
  begin
    case key of
      VK_Escape, VK_Return : KeyDown(Key,Shift);
    end;
  end;
  if (ssAlt in Shift) and (Key = VK_Down) then KeyDown(Key,Shift);
end;

procedure TTntExDropDownRichEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (operation = opRemove) and assigned(FRichEdit) and (AComponent = FRichEdit.PopupMenu) then FRichEdit.PopupMenu := nil;
end;

end.
