{*****************************************************************************}
{                                                                             }
{    Tnt Extended Editors                                                     }
{      http://lummie.co.uk                                                    }
{        Version: 1.0.3                                                       }
{                                                                             }
{    Copyright (c) 2005 Matt harrison (http://www.lummie.co.uk)               }
{    Descended from TNT Controls                                              }
{        Copyright (c) 2002, 2003 Troy Wolbrink (troy.wolbrink@ccci.org)      }                                                                   
{                                                                             }
{*****************************************************************************}
unit TntExIntegerEdit;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, TntStdCtrls, tntComctrls, windows, messages, comctrls,
  TntExWinControl, Forms, commctrl, Themes;

type
  TTntExUpDown = class(TTntCustomUpDown)
  // we need to create a class of Up Down with out the Associate proeprty published
  // otherwise the control will not
  published
    property AlignButton;
    property ArrowKeys;
    property Enabled;
    property Hint;
    property Min;
    property Max;
    property Increment;
    property Orientation;
    property ParentShowHint;
    property PopupMenu;
    property Position;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Thousands;
    property Visible;
    property Wrap;
    property OnChanging;
    property OnChangingEx;
    property OnContextPopup;
    property OnClick;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;


  TCustomTntExIntegerEdit = class(TTntExWinControl)
  private
    { Private declarations }
    FEdit : TTntEdit;
    FSpin : TTntExUpDown;
  protected
    { Protected declarations }
    procedure CreateWnd; override;
    procedure PositionControls(ARect : TRect); virtual;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    property Edit : TTntEdit read FEdit;
    property Spin : TTntExUpDown read FSpin;
    procedure AdjustClientRect(var Rect: TRect); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  TTntExIntegerEdit = class(TCustomTntExIntegerEdit)
  published
    { Published declarations }
    property Edit;
    property Spin;
    property Hint;

    property Action;
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderWidth;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
  end;

implementation

{ TTntExButtonEdit }


{ TTntExIntegerEdit }

procedure TCustomTntExIntegerEdit.AdjustClientRect(var Rect: TRect);
begin
  inherited;
  PositionControls(Rect);
end;

constructor TCustomTntExIntegerEdit.Create(AOwner: TComponent);
begin
  inherited;
  Height := 21;
  Width := 121;
  FEdit := TTntEdit.Create(self);
  FEdit.SetSubComponent(true);
  FEdit.Name := 'Edit';
  FEdit.AutoSize := false;
  FSpin := TTntExUpDown.create(self);
  FSpin.SetSubComponent(true);
  FSpin.Name := 'Spin';
  FEdit.BorderStyle := bsNone;
end;

procedure TCustomTntExIntegerEdit.CreateWnd;
begin
  inherited;
  FEdit.Parent := self;
  FSpin.Parent := self;
  FSpin.Associate := FEdit;
  PositionControls(ClientRect);
end;

destructor TCustomTntExIntegerEdit.Destroy;
begin
  inherited;
end;

procedure TCustomTntExIntegerEdit.PositionControls(ARect : TRect);
var
  c : TRect;
begin
  c := ARect;
  if ThemeServices.ThemesEnabled then
  begin
    if FSpin.AlignButton = udLeft then
    begin
      FEdit.Perform(EM_SETMARGINS,EC_LEFTMARGIN,2 + FSpin.width);
      FEdit.SetBounds(c.left+1 - FSpin.width,c.top+1,width+FSpin.width-4,height-4);
      FSpin.Height := FEdit.height;
      if FSpin.HandleAllocated and FEdit.HandleAllocated and HandleAllocated then
        SendMessage(FSpin.Handle, UDM_SETBUDDY, FEdit.Handle, 0);
    end
    else
    begin
      FEdit.Perform(EM_SETMARGINS,EC_LEFTMARGIN,2);
      FEdit.SetBounds(c.left+1,c.top+1,width+FSpin.width-4,height-4);
      FSpin.Height := FEdit.height;
      if FSpin.HandleAllocated and FEdit.HandleAllocated and HandleAllocated then
        SendMessage(FSpin.Handle, UDM_SETBUDDY, FEdit.Handle, 0);
    end;
  end
  else
  begin
    if FSpin.AlignButton = udLeft then
    begin
      FEdit.Perform(EM_SETMARGINS,EC_LEFTMARGIN,2 + FSpin.width);
      FEdit.SetBounds(c.left - FSpin.width,c.top,width+FSpin.width-6,height-6);
      FSpin.Height := FEdit.height;
      if FSpin.HandleAllocated and FEdit.HandleAllocated and HandleAllocated then
        SendMessage(FSpin.Handle, UDM_SETBUDDY, FEdit.Handle, 0);
    end
    else
    begin
      FEdit.Perform(EM_SETMARGINS,EC_LEFTMARGIN,2);
      FEdit.SetBounds(c.left,c.top,width+FSpin.width-6,height-6);
      FSpin.Height := FEdit.height;
      if FSpin.HandleAllocated and FEdit.HandleAllocated and HandleAllocated then
        SendMessage(FSpin.Handle, UDM_SETBUDDY, FEdit.Handle, 0);
    end;
  end;
end;

procedure TCustomTntExIntegerEdit.WMSize(var Message: TWMSize);
begin
  inherited;
end;

end.
